// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.13.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.DataLake.Analytics.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The Data Lake Analytics U-SQL job state audit records for tracking the
    /// lifecycle of a job.
    /// </summary>
    public partial class JobStateAuditRecord
    {
        /// <summary>
        /// Initializes a new instance of the JobStateAuditRecord class.
        /// </summary>
        public JobStateAuditRecord() { }

        /// <summary>
        /// Initializes a new instance of the JobStateAuditRecord class.
        /// </summary>
        public JobStateAuditRecord(string newState = default(string), DateTime? timeStamp = default(DateTime?), string requestedByUser = default(string), string details = default(string))
        {
            NewState = newState;
            TimeStamp = timeStamp;
            RequestedByUser = requestedByUser;
            Details = details;
        }

        /// <summary>
        /// Gets or sets the new state the job is in.
        /// </summary>
        [JsonProperty(PropertyName = "newState")]
        public string NewState { get; set; }

        /// <summary>
        /// Gets or sets the time stamp that the state change took place.
        /// </summary>
        [JsonProperty(PropertyName = "timeStamp")]
        public DateTime? TimeStamp { get; set; }

        /// <summary>
        /// Gets or sets the user who requests the change.
        /// </summary>
        [JsonProperty(PropertyName = "requestedByUser")]
        public string RequestedByUser { get; set; }

        /// <summary>
        /// Gets or sets  the details of the audit log.
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public string Details { get; set; }

    }
}
