// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Automation.Models;

namespace Microsoft.WindowsAzure.Management.Automation.Models
{
    public partial class AutomationAccountCreateParameters
    {
        private CloudServiceSettings _cloudServiceSettings;
        
        /// <summary>
        /// Required. Gets or sets the cloud service settings.
        /// </summary>
        public CloudServiceSettings CloudServiceSettings
        {
            get { return this._cloudServiceSettings; }
            set { this._cloudServiceSettings = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. Gets or sets the account name.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AutomationAccountCreateParameters
        /// class.
        /// </summary>
        public AutomationAccountCreateParameters()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the AutomationAccountCreateParameters
        /// class with required arguments.
        /// </summary>
        public AutomationAccountCreateParameters(string name, CloudServiceSettings cloudServiceSettings)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (cloudServiceSettings == null)
            {
                throw new ArgumentNullException("cloudServiceSettings");
            }
            this.Name = name;
            this.CloudServiceSettings = cloudServiceSettings;
        }
    }
}
