// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.Automation.Models;

namespace Microsoft.WindowsAzure.Management.Automation.Models
{
    /// <summary>
    /// Definition of the runbook property type.
    /// </summary>
    public partial class RunbookProperties
    {
        private DateTimeOffset _creationTime;
        
        /// <summary>
        /// Optional. Gets or sets the creation time of the runbook.
        /// </summary>
        public DateTimeOffset CreationTime
        {
            get { return this._creationTime; }
            set { this._creationTime = value; }
        }
        
        private string _description;
        
        /// <summary>
        /// Optional. Gets or sets the description of the runbook.
        /// </summary>
        public string Description
        {
            get { return this._description; }
            set { this._description = value; }
        }
        
        private RunbookDraft _draft;
        
        /// <summary>
        /// Optional. Gets or sets the draft runbook properties.
        /// </summary>
        public RunbookDraft Draft
        {
            get { return this._draft; }
            set { this._draft = value; }
        }
        
        private int _jobCount;
        
        /// <summary>
        /// Optional. Gets or sets the job count of the runbook.
        /// </summary>
        public int JobCount
        {
            get { return this._jobCount; }
            set { this._jobCount = value; }
        }
        
        private DateTimeOffset _lastModifiedTime;
        
        /// <summary>
        /// Optional. Gets or sets the last modified time of the runbook.
        /// </summary>
        public DateTimeOffset LastModifiedTime
        {
            get { return this._lastModifiedTime; }
            set { this._lastModifiedTime = value; }
        }
        
        private bool _logProgress;
        
        /// <summary>
        /// Optional. Gets or sets progress log option.
        /// </summary>
        public bool LogProgress
        {
            get { return this._logProgress; }
            set { this._logProgress = value; }
        }
        
        private bool _logVerbose;
        
        /// <summary>
        /// Optional. Gets or sets verbose log option.
        /// </summary>
        public bool LogVerbose
        {
            get { return this._logVerbose; }
            set { this._logVerbose = value; }
        }
        
        private IDictionary<string, RunbookParameter> _parameters;
        
        /// <summary>
        /// Optional. Gets or sets the runbook parameters.
        /// </summary>
        public IDictionary<string, RunbookParameter> Parameters
        {
            get { return this._parameters; }
            set { this._parameters = value; }
        }
        
        private RunbookProvisioningState _provisioningState;
        
        /// <summary>
        /// Optional. Gets or sets the provisioning state of the runbook.
        /// </summary>
        public RunbookProvisioningState ProvisioningState
        {
            get { return this._provisioningState; }
            set { this._provisioningState = value; }
        }
        
        private ContentLink _publishContentLink;
        
        /// <summary>
        /// Optional. Gets or sets the published runbook content link.
        /// </summary>
        public ContentLink PublishContentLink
        {
            get { return this._publishContentLink; }
            set { this._publishContentLink = value; }
        }
        
        private string _runbookType;
        
        /// <summary>
        /// Optional. Gets or sets the type of the runbook.
        /// </summary>
        public string RunbookType
        {
            get { return this._runbookType; }
            set { this._runbookType = value; }
        }
        
        private string _serviceManagementTags;
        
        /// <summary>
        /// Optional. Gets or sets the service management tags of the runbook.
        /// </summary>
        public string ServiceManagementTags
        {
            get { return this._serviceManagementTags; }
            set { this._serviceManagementTags = value; }
        }
        
        private string _state;
        
        /// <summary>
        /// Optional. Gets or sets the state of the runbook.
        /// </summary>
        public string State
        {
            get { return this._state; }
            set { this._state = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the RunbookProperties class.
        /// </summary>
        public RunbookProperties()
        {
            this.Parameters = new LazyDictionary<string, RunbookParameter>();
        }
    }
}
