// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// The compute image attributes
    /// </summary>
    public partial class ComputeImageAttributes
    {
        private string _offer;
        
        /// <summary>
        /// Required. Gets or sets the publisher defined name of the offer.The
        /// allowed characters are uppercase or lowercase letters, digit,
        /// hypen(-), period (.).The maximum allowed length is 64 characters.
        /// </summary>
        public string Offer
        {
            get { return this._offer; }
            set { this._offer = value; }
        }
        
        private string _sku;
        
        /// <summary>
        /// Required. Gets or sets the publisher defined name of the Sku. The
        /// allowed characters are uppercase or lowercase letters, digit,
        /// hypen(-), period (.). The maximum allowed length is 64 characters.
        /// </summary>
        public string Sku
        {
            get { return this._sku; }
            set { this._sku = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Required. Gets or sets the publisher defined version of the image.
        /// The allowed characters are digit and period. Format:
        /// <MajorVersion>.<MinorVersion>.<Patch>Example: '1.0.0' or '1.1.0'
        /// The 3 version number to follow standard of most of the RPs.See
        /// http://semver.org/.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ComputeImageAttributes class.
        /// </summary>
        public ComputeImageAttributes()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the ComputeImageAttributes class with
        /// required arguments.
        /// </summary>
        public ComputeImageAttributes(string offer, string sku, string version)
            : this()
        {
            if (offer == null)
            {
                throw new ArgumentNullException("offer");
            }
            if (sku == null)
            {
                throw new ArgumentNullException("sku");
            }
            if (version == null)
            {
                throw new ArgumentNullException("version");
            }
            this.Offer = offer;
            this.Sku = sku;
            this.Version = version;
        }
    }
}
