// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Declared local resources used inside guest VM by the extension.
    /// Optional.
    /// </summary>
    public partial class ExtensionLocalResourceConfiguration
    {
        private string _name;
        
        /// <summary>
        /// Required. Required. Description of a local resource entry.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private int? _sizeInMB;
        
        /// <summary>
        /// Optional. Optional. Size (in MB) of the local resource entry.
        /// </summary>
        public int? SizeInMB
        {
            get { return this._sizeInMB; }
            set { this._sizeInMB = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ExtensionLocalResourceConfiguration class.
        /// </summary>
        public ExtensionLocalResourceConfiguration()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ExtensionLocalResourceConfiguration class with required arguments.
        /// </summary>
        public ExtensionLocalResourceConfiguration(string name)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            this.Name = name;
        }
    }
}
