// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class respresents status of volume container (Cloud Configuration)
    /// migrated.
    /// </summary>
    public partial class MigrationDataContainerStatus
    {
        private IList<MigrationBackupSet> _backupSets;
        
        /// <summary>
        /// Required. Gets or sets the status of all backup being migrated for
        /// the given volume container
        /// </summary>
        public IList<MigrationBackupSet> BackupSets
        {
            get { return this._backupSets; }
            set { this._backupSets = value; }
        }
        
        private string _cloudConfigurationName;
        
        /// <summary>
        /// Required. Gets or sets the name of the volume container
        /// </summary>
        public string CloudConfigurationName
        {
            get { return this._cloudConfigurationName; }
            set { this._cloudConfigurationName = value; }
        }
        
        private HcsMessageInfo _messageInfo;
        
        /// <summary>
        /// Required. Gets or sets the volume container level message or
        /// recommendation, usually when an error is encountered during
        /// migration
        /// </summary>
        public HcsMessageInfo MessageInfo
        {
            get { return this._messageInfo; }
            set { this._messageInfo = value; }
        }
        
        private int _percentageCompleted;
        
        /// <summary>
        /// Required. Gets or sets percentage of migration completed
        /// </summary>
        public int PercentageCompleted
        {
            get { return this._percentageCompleted; }
            set { this._percentageCompleted = value; }
        }
        
        private MigrationStatus _status;
        
        /// <summary>
        /// Required. Gets or sets status of the migration
        /// </summary>
        public MigrationStatus Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the MigrationDataContainerStatus
        /// class.
        /// </summary>
        public MigrationDataContainerStatus()
        {
            this.BackupSets = new LazyList<MigrationBackupSet>();
        }
    }
}
