// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.WindowsAzure.Management.StorSimple.Models;

namespace Microsoft.WindowsAzure.Management.StorSimple.Models
{
    /// <summary>
    /// This class respresents the details for backup schedules & volumes under
    /// the backup policy.
    /// </summary>
    public partial class NewBackupPolicyConfig
    {
        private IList<BackupScheduleBase> _backupSchedules;
        
        /// <summary>
        /// Required. The backup schedules under this backup policy.
        /// </summary>
        public IList<BackupScheduleBase> BackupSchedules
        {
            get { return this._backupSchedules; }
            set { this._backupSchedules = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Required. The name of the entity
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private IList<string> _volumeIds;
        
        /// <summary>
        /// Required. The list of volume ids under this backup policy.
        /// </summary>
        public IList<string> VolumeIds
        {
            get { return this._volumeIds; }
            set { this._volumeIds = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the NewBackupPolicyConfig class.
        /// </summary>
        public NewBackupPolicyConfig()
        {
            this.BackupSchedules = new List<BackupScheduleBase>();
            this.VolumeIds = new List<string>();
        }
        
        /// <summary>
        /// Initializes a new instance of the NewBackupPolicyConfig class with
        /// required arguments.
        /// </summary>
        public NewBackupPolicyConfig(string name, List<BackupScheduleBase> backupSchedules, List<string> volumeIds)
            : this()
        {
            if (name == null)
            {
                throw new ArgumentNullException("name");
            }
            if (backupSchedules == null)
            {
                throw new ArgumentNullException("backupSchedules");
            }
            if (volumeIds == null)
            {
                throw new ArgumentNullException("volumeIds");
            }
            this.Name = name;
            this.BackupSchedules = backupSchedules;
            this.VolumeIds = volumeIds;
        }
    }
}
