// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.TrafficManager.Models
{
    /// <summary>
    /// Describes the option to use when making an HTTP request to monitor
    /// endpoint health.
    /// </summary>
    public partial class DefinitionMonitorHTTPOptions
    {
        private int _expectedStatusCode;
        
        /// <summary>
        /// Optional. Specifies the HTTP status code expected from a healthy
        /// endpoint. Endpoint is considered unhealthy otherwise.
        /// </summary>
        public int ExpectedStatusCode
        {
            get { return this._expectedStatusCode; }
            set { this._expectedStatusCode = value; }
        }
        
        private string _relativePath;
        
        /// <summary>
        /// Optional. Specifies the path relative to the endpoint domain name
        /// to probe for health state. For restrictions, see
        /// http://msdn.microsoft.com/en-us/library/hh758254.aspx.
        /// </summary>
        public string RelativePath
        {
            get { return this._relativePath; }
            set { this._relativePath = value; }
        }
        
        private string _verb;
        
        /// <summary>
        /// Optional. Specifies the verb to use when making an HTTP request to
        /// monitor endpoint health.
        /// </summary>
        public string Verb
        {
            get { return this._verb; }
            set { this._verb = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DefinitionMonitorHTTPOptions
        /// class.
        /// </summary>
        public DefinitionMonitorHTTPOptions()
        {
        }
    }
}
